/*    
	This file is part of Moose.

    Moose is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as 
    published by the Free Software Foundation, either version 3 of 
    the License, or (at your option) any later version.

    Moose is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public 
    License along with Moose.  If not, see <http://www.gnu.org/licenses/>.
*/

package com.quigley.moose.handler;

import java.util.Calendar;
import java.util.Date;

import javax.xml.bind.DatatypeConverter;

import com.quigley.moose.mapping.MappingException;

public class DateHandler implements TypeHandler {
	public Object getObject(String text) {
		try {
			return DatatypeConverter.parseDateTime(text).getTime();
			
		} catch(Exception e) {
			throw new MappingException("Invalid date format '" + text + "'.", e);
		}
	}
	public String getText(Object object) {
		Calendar calendar = Calendar.getInstance();
		calendar.setTime((Date) object);
		return DatatypeConverter.printDateTime(calendar);
	}
	public String getXsdType(String namespacePrefix) {
		return "xs:dateTime";
	}
}