/*    
	This file is part of Moose.

    Moose is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as 
    published by the Free Software Foundation, either version 3 of 
    the License, or (at your option) any later version.

    Moose is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public 
    License along with Moose.  If not, see <http://www.gnu.org/licenses/>.
*/

package com.quigley.moose.mapping;

import org.jdom.Element;

import com.quigley.moose.handler.TypeHandler;

public class MappedAttributeField extends MappedField {
	@Override
	public void marshall(Object instance, Mapping mapping, MarshallingContext ctx) {
		Object fieldObject = invokeGetter(instance);
		if(fieldObject != null) {
			Class<?> fieldClass = getFieldType(instance.getClass());
			
			ctx.getOutput().append(" ").append(xmlName).append("=\"");
			ctx.getOutput().append(mapping.getTypeHandler(fieldClass).getText(fieldObject));
			ctx.getOutput().append("\"");
		}
	}

	@Override
	public void unmarshall(Object instance, Element element, Mapping mapping) {
		Class<?> fieldClass = getFieldType(instance.getClass());
		TypeHandler typeHandler = mapping.getTypeHandler(fieldClass);
		Object fieldObject = typeHandler.getObject(element.getAttributeValue(xmlName));
		invokeSetter(instance, fieldObject);
	}
}