/*    
	This file is part of Moose.

    Moose is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as 
    published by the Free Software Foundation, either version 3 of 
    the License, or (at your option) any later version.

    Moose is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public 
    License along with Moose.  If not, see <http://www.gnu.org/licenses/>.
*/

package com.quigley.moose.mapping;

import org.jdom.Element;
import org.springframework.beans.factory.annotation.Required;

@SuppressWarnings("rawtypes")
public abstract class MappedType {
	public abstract void marshall(Object instance, String alternateName, Mapping mapping, MarshallingContext ctx);
	public abstract Object unmarshall(Element element, Mapping mapping);
	
	public Class getClazz() {
		return clazz;
	}
	@Required
	public void setClazz(Class clazz) {
		this.clazz = clazz;
	}

	protected Class clazz;
}